#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <inttypes.h>

int equals_1(uint8_t *a, uint8_t *b) {
  return (a[0] == b[0]) && (a[1] == b[1]) && (a[2] == b[2]) && (a[3] == b[3]);
}

int equals_2(uint8_t *a, uint8_t *b) {
  return (a[3] == b[3]) && (a[2] == b[2]) && (a[1] == b[1]) && (a[0] == b[0]);
}

int equals_3(uint8_t *a, uint8_t *b) {
  return memcmp(a,b,sizeof(int)) == 0;
}

int equals_4(uint8_t *a, uint8_t *b) {
  return *((int*)a) == *((int*)b);
}

#define LOOPCOUNT 1000000


int test1(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_1(a,b);
  return z;
}

int test2(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_1(a,b);
  return z;
}

int test3(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_1(a,b);
  return z;
}


int test4(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_2(a,b);
  return z;
}

int test5(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_2(a,b);
  return z;
}

int test6(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_2(a,b);
  return z;
}

int test7(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_3(a,b);
  return z;
}

int test8(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_3(a,b);
  return z;
}

int test9(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_3(a,b);
  return z;
}


int test10(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_4(a,b);
  return z;
}

int test11(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_4(a,b);
  return z;
}

int test12(uint8_t *a, uint8_t *b) {
  int i; int z = 0;
  for ( i = 0; i < LOOPCOUNT; i++) z += equals_4(a,b);
  return z;
}


void main(int argc, char **argv) {
  int a = 0x00000000;
  int b = 0x00000000;

  int c = 0x01000000;
  int d = 0x02000000;

  int e = 0x00000001;
  int f = 0x00000002;

  int z = 0;
  z += test1((uint8_t*)&a,(uint8_t*)&b);
  z += test2((uint8_t*)&c,(uint8_t*)&d);
  z += test3((uint8_t*)&e,(uint8_t*)&f);

  z += test4((uint8_t*)&a,(uint8_t*)&b);
  z += test5((uint8_t*)&c,(uint8_t*)&d);
  z += test6((uint8_t*)&e,(uint8_t*)&f);

  z += test7((uint8_t*)&a,(uint8_t*)&b);
  z += test8((uint8_t*)&c,(uint8_t*)&d);
  z += test9((uint8_t*)&e,(uint8_t*)&f);

  z += test10((uint8_t*)&a,(uint8_t*)&b);
  z += test11((uint8_t*)&c,(uint8_t*)&d);
  z += test12((uint8_t*)&e,(uint8_t*)&f);


  printf("Z: %d\n",z);
}